
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	dx		pow(10,-4)	//the width of box
#define	N1		10000		//the number of random
#define	N2		10000		//the numebr of trial
dsfmt_t dsfmt1;				//random number


double rand_gauss( double mu , double sigma ){	//rand : gauss
	double x1 = dsfmt_genrand_close_open(&dsfmt1);
	double x2 = dsfmt_genrand_close_open(&dsfmt1);
	double y  = sigma * ( sqrt(-2 * log(x1) ) * cos( 2*M_PI * x2)) + mu;
	return y;
}

void PDF_normal( double *data , int data_num ,double data_min , int imax , double *output){	//PDF
	int i ;
	
	for( i=0 ; i<data_num ; i++ ){
		output[(int)( ( data[i] - data_min )/dx) ] += 1.0/data_num;
	}
	for( i=0 ; i<imax ; i++){
		output[i] /= dx;
	}
}

int double_comp(const void *_a, const void *_b) {	//qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main(void){
	
	//Seed of random number
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int i, j;
	double sum;
	double *rand ,*ave , *med ;
	double *F_ave , *F_med;
	rand = (double *)calloc( N1 , sizeof(double) );
	ave = (double *)calloc( N2 , sizeof(double) );
	med = (double *)calloc( N2 , sizeof(double) );
	double data_min , data_max;
	int imax;
	char *fn;
	fn = (char *)calloc( 100 ,sizeof(char));
	FILE *fpave , *fpmed;
	if( (fpave = fopen("output/ave.dat" , "w") ) ==NULL){
		printf("FILE Error: ave\n");
		exit(1);
	}
	if( (fpmed = fopen("output/med.dat" , "w") ) ==NULL){
		printf("FILE Error:med\n");
		exit(1);
	}
	
	for( i=0; i<N2 ; i++){	//trial
		sum = 0.0;
		for( j=0; j<N1; j++){	//generate the random number
			rand[j] = rand_gauss(0,1);
			sum += rand[j];
		}
		ave[i] = sum/N1;
		qsort(rand,N1,sizeof(double),double_comp);
		med[i] = (rand[(int) (N1/2)-1] + rand[(int) (N1/2)])/2.0;
	}
	
	//ave
	qsort( ave  , N2 , sizeof(double) , double_comp );
	data_max = ave[0];
	data_min = ave[N2-1];
	imax = (int)( ( data_max - data_min )/dx ) + 1;
	F_ave = (double * )calloc( imax , sizeof(double) );
	PDF_normal( ave , N2, data_min , imax , F_ave );
	for(i=0;i<imax;i++)	fprintf( fpave , "%f %f\n", data_min+(i+0.5)*dx ,F_ave[i]);
	
	//med
	qsort( med  , N2 , sizeof(double) , double_comp );
	data_max = med[0];
	data_min = med[N2-1];
	imax = (int)( ( data_max - data_min )/dx ) + 1;
	F_med = (double * )calloc( imax , sizeof(double) );
	PDF_normal( med , N2, data_min , imax , F_med );
	for(i=0;i<imax;i++)	fprintf( fpmed , "%f %f\n", data_min+(i+0.5)*dx ,F_med[i]);
	
	
	fclose(fpave);
	fclose(fpmed);
	free(ave);
	free(med);
	free(F_ave);
	free(F_med);
	
	return 0;
}



